function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["isCollapsible", "isOpen", "description", "children"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React from 'react';
import { IconKeyboardArrowDown } from '@defencedigital/icon-library';
import { DescriptionListItem } from '.';
import { warnIfOverwriting } from '../../helpers';
import { useOpenClose } from '../../hooks';
import { StyledAction } from './partials/StyledAction';
import { StyledBadge } from './partials/StyledBadge';
import { StyledDescriptionList } from './partials/StyledDescriptionList';
import { StyledHeader } from './partials/StyledHeader';
import { StyledSheet } from './partials/StyledSheet';
import { StyledDescription } from './partials/StyledDescription';
import { useExternalId } from '../../hooks/useExternalId';
function useAriaAttributes(isCollapsible, expanded) {
  var sheetId = useExternalId('sheet');
  if (isCollapsible) {
    return {
      'aria-expanded': expanded,
      'aria-label': expanded ? 'Hide data' : 'Show data',
      'aria-owns': sheetId
    };
  }
  return null;
}
export var DescriptionList = function DescriptionList(_ref) {
  var _ref$isCollapsible = _ref.isCollapsible,
    isCollapsible = _ref$isCollapsible === void 0 ? false : _ref$isCollapsible,
    _ref$isOpen = _ref.isOpen,
    isOpen = _ref$isOpen === void 0 ? false : _ref$isOpen,
    description = _ref.description,
    children = _ref.children,
    rest = _objectWithoutProperties(_ref, _excluded);
  var _useOpenClose = useOpenClose(isOpen),
    open = _useOpenClose.open,
    toggle = _useOpenClose.toggle;
  var ariaAttributes = useAriaAttributes(isCollapsible, open);
  var sheetId = ariaAttributes ? ariaAttributes['aria-owns'] : undefined;
  return /*#__PURE__*/React.createElement(StyledDescriptionList, _extends({
    $isCollapsible: isCollapsible,
    $isOpen: open
  }, rest), /*#__PURE__*/React.createElement(StyledHeader, _extends({
    $isCollapsible: isCollapsible,
    onClick: toggle
  }, ariaAttributes), /*#__PURE__*/React.createElement(StyledDescription, null, description, isCollapsible && /*#__PURE__*/React.createElement(StyledBadge, {
    $isCollapsible: isCollapsible,
    size: "small"
  }, children.length)), /*#__PURE__*/React.createElement(StyledAction, {
    $isCollapsible: isCollapsible,
    $isOpen: open
  }, /*#__PURE__*/React.createElement(IconKeyboardArrowDown, {
    "aria-hidden": true
  }))), /*#__PURE__*/React.createElement(StyledSheet, {
    $isCollapsible: isCollapsible,
    $isOpen: open,
    id: sheetId
  }, React.Children.map(children, function (child) {
    warnIfOverwriting(child.props, 'isCollapsible', DescriptionListItem.name);
    return /*#__PURE__*/React.cloneElement(child, _objectSpread(_objectSpread({}, child.props), {}, {
      isCollapsible: isCollapsible
    }));
  })));
};
DescriptionList.displayName = 'DescriptionList';