var _excluded = ["hasCheckbox", "children", "onDismiss", "title"];
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0) { ; } } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { useState } from 'react';
import { Button, BUTTON_VARIANT } from '../Button';
import { COMPONENT_SIZE } from '../Forms';
import { StyledDismissibleBanner } from './partials/StyledDismissibleBanner';
import { StyledContent } from './partials/StyledContent';
import { StyledTitle } from './partials/StyledTitle';
import { StyledFooter } from './partials/StyledFooter';
import { StyledDontShow } from './partials/StyledDontShow';
import { StyledDescription } from './partials/StyledDescription';
import { CHECKBOX_RADIO_VARIANT } from '../CheckboxRadioBase';
export var DismissibleBanner = function DismissibleBanner(_ref) {
  var _ref$hasCheckbox = _ref.hasCheckbox,
    hasCheckbox = _ref$hasCheckbox === void 0 ? true : _ref$hasCheckbox,
    children = _ref.children,
    onDismiss = _ref.onDismiss,
    title = _ref.title,
    rest = _objectWithoutProperties(_ref, _excluded);
  var _useState = useState(true),
    _useState2 = _slicedToArray(_useState, 2),
    canShowAgain = _useState2[0],
    setCanShowAgain = _useState2[1];
  var onButtonClick = function onButtonClick(event) {
    onDismiss === null || onDismiss === void 0 ? void 0 : onDismiss(event, canShowAgain);
  };
  return /*#__PURE__*/React.createElement(StyledDismissibleBanner, rest, /*#__PURE__*/React.createElement(StyledContent, null, title && /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(StyledTitle, null, title), /*#__PURE__*/React.createElement(StyledDescription, null, children)), !title && children), /*#__PURE__*/React.createElement(StyledFooter, null, hasCheckbox && /*#__PURE__*/React.createElement(StyledDontShow, {
    label: "Don't show this again",
    name: "dimissiblebanner-dontshow",
    onChange: function onChange() {
      return setCanShowAgain(!canShowAgain);
    },
    variant: CHECKBOX_RADIO_VARIANT.NO_CONTAINER
  }), !hasCheckbox && /*#__PURE__*/React.createElement("span", null), /*#__PURE__*/React.createElement(Button, {
    onClick: onButtonClick,
    size: COMPONENT_SIZE.SMALL,
    variant: BUTTON_VARIANT.SECONDARY
  }, "Dismiss")));
};
DismissibleBanner.displayName = 'DismissibleBanner';