var _excluded = ["children", "onClose", "isOpen", "className"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { forwardRef } from 'react';
import { IconClose } from '@defencedigital/icon-library';
import { useOpenClose } from '../../hooks/useOpenClose';
import { StyledDrawer } from './partials/StyledDrawer';
import { StyledDrawerInner } from './partials/StyledDrawerInner';
import { StyledDrawerButton } from './partials/StyledDrawerButton';
import { StyledDrawerContent } from './partials/StyledDrawerContent';
export var Drawer = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var children = _ref.children,
    onClose = _ref.onClose,
    _ref$isOpen = _ref.isOpen,
    isOpen = _ref$isOpen === void 0 ? false : _ref$isOpen,
    className = _ref.className,
    rest = _objectWithoutProperties(_ref, _excluded);
  var _useOpenClose = useOpenClose(isOpen, onClose),
    handleOnClose = _useOpenClose.handleOnClose,
    open = _useOpenClose.open;
  return /*#__PURE__*/React.createElement(StyledDrawer, _extends({
    className: className,
    $isOpen: open,
    ref: ref
  }, rest), /*#__PURE__*/React.createElement(StyledDrawerInner, null, /*#__PURE__*/React.createElement(StyledDrawerButton, {
    onClick: handleOnClose,
    "aria-label": "close"
  }, /*#__PURE__*/React.createElement(IconClose, null)), /*#__PURE__*/React.createElement(StyledDrawerContent, null, children)));
});
Drawer.displayName = 'Drawer';