function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import React from 'react';
import { action } from '@storybook/addon-actions';
import { IconLayers, IconAnchor } from '@defencedigital/icon-library';
import styled from 'styled-components';
import { Dropdown } from './Dropdown';
export default {
  argTypes: {
    labelIcon: {
      control: false
    }
  },
  component: Dropdown,
  title: 'Dropdown',
  parameters: {
    actions: {
      argTypesRegex: '^on.*'
    },
    docs: {
      description: {
        component: 'This component wraps a popular open-source library. See comprehensive documentation [here](https://github.com/JedWatson/react-select#readme).'
      }
    }
  }
};
var options = [{
  value: 'option',
  label: 'Option'
}, {
  value: 'visible',
  label: 'Visible',
  isVisible: true
}, {
  value: 'hidden',
  label: 'Hidden',
  isHidden: true
}, {
  value: 'disabled',
  label: 'Disabled',
  isDisabled: true
}];
var StyledWrapper = styled.div.withConfig({
  displayName: "Dropdownstories__StyledWrapper",
  componentId: "sc-ktmt8n-0"
})(["height:15rem;"]);
var Template = function Template(props) {
  return /*#__PURE__*/React.createElement(StyledWrapper, null, /*#__PURE__*/React.createElement(Dropdown, props));
};
export var Default = Template.bind({});
Default.args = {
  options: options,
  label: 'Example label'
};
export var Open = Template.bind({});
Open.storyName = 'Open';
Open.args = {
  options: options,
  initialIsOpen: true,
  label: 'Example label'
};
var iconOptions = options.map(function (option) {
  return _objectSpread(_objectSpread({}, option), {}, {
    icon: /*#__PURE__*/React.createElement(IconAnchor, null)
  });
});
export var WithIcons = function WithIcons(props) {
  return /*#__PURE__*/React.createElement(StyledWrapper, null, /*#__PURE__*/React.createElement(Dropdown, _extends({}, props, {
    options: iconOptions,
    label: "Example label",
    labelIcon: /*#__PURE__*/React.createElement(IconLayers, null),
    onSelect: action('onSelect')
  })));
};
WithIcons.storyName = 'With icons';