function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import React, { useMemo } from 'react';
import { StyledField } from './partials/StyledField';
import { StyledError } from './partials/StyledError';
import { StyledHintText } from './partials/StyledHintText';
import { useExternalId } from '../../hooks/useExternalId';
export function ariaAttributes(isInvalid, fieldId) {
  return _objectSpread({
    'aria-describedby': fieldId
  }, isInvalid && {
    'aria-errormessage': "".concat(fieldId, "-errormessage"),
    'aria-invalid': true
  });
}
export var Field = function Field(_ref) {
  var children = _ref.children,
    _ref$errors = _ref.errors,
    errors = _ref$errors === void 0 ? [] : _ref$errors,
    hintText = _ref.hintText,
    className = _ref.className;
  var isInvalid = useMemo(function () {
    return errors.some(function (_ref2) {
      var error = _ref2.error;
      return error;
    });
  }, [errors]);
  var fieldId = useExternalId('field');
  return /*#__PURE__*/React.createElement(StyledField, {
    className: className
  }, isInvalid && errors.map(function (_ref3) {
    var error = _ref3.error;
    return error && typeof error === 'string' && /*#__PURE__*/React.createElement(StyledError, {
      id: "".concat(fieldId, "-errormessage"),
      key: error,
      role: "alert"
    }, error);
  }), React.Children.map(children, function (child) {
    if (! /*#__PURE__*/React.isValidElement(child)) {
      return null;
    }
    return /*#__PURE__*/React.cloneElement(child, _objectSpread(_objectSpread(_objectSpread({}, child.props), ariaAttributes(isInvalid, fieldId)), {}, {
      isInvalid: isInvalid
    }));
  }), hintText && /*#__PURE__*/React.createElement(StyledHintText, {
    id: fieldId
  }, hintText));
};
Field.displayName = 'Field';