function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["aria-label", "children", "className", "descriptionId", "isOpen", "onClose", "primaryButton", "secondaryButton", "tertiaryButton", "title", "titleId"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React from 'react';
import { IconForward } from '@defencedigital/icon-library';
import { Footer } from './Footer';
import { Header } from './Header';
import { StyledModal } from './partials/StyledModal';
import { StyledMain } from './partials/StyledMain';
import { useExternalId } from '../../hooks/useExternalId';
import { useOpenClose } from '../../hooks/useOpenClose';
export var Modal = function Modal(_ref) {
  var ariaLabel = _ref['aria-label'],
    children = _ref.children,
    className = _ref.className,
    externalDescriptionId = _ref.descriptionId,
    _ref$isOpen = _ref.isOpen,
    isOpen = _ref$isOpen === void 0 ? false : _ref$isOpen,
    onClose = _ref.onClose,
    primaryButton = _ref.primaryButton,
    secondaryButton = _ref.secondaryButton,
    tertiaryButton = _ref.tertiaryButton,
    title = _ref.title,
    externalTitleId = _ref.titleId,
    rest = _objectWithoutProperties(_ref, _excluded);
  var _useOpenClose = useOpenClose(isOpen, onClose),
    handleOnClose = _useOpenClose.handleOnClose,
    open = _useOpenClose.open;
  var primaryButtonWithIcon = primaryButton && _objectSpread({
    icon: /*#__PURE__*/React.createElement(IconForward, null)
  }, primaryButton);
  var descriptionId = useExternalId('modal-description', externalDescriptionId);
  var titleId = useExternalId('modal-title', externalTitleId);
  return /*#__PURE__*/React.createElement(StyledModal, _extends({
    $isOpen: open,
    className: className,
    role: "dialog",
    "aria-modal": true,
    "aria-label": ariaLabel,
    "aria-labelledby": (title || externalTitleId) && !ariaLabel ? titleId : undefined,
    "aria-describedby": descriptionId
  }, rest), /*#__PURE__*/React.createElement(StyledMain, null, title && /*#__PURE__*/React.createElement(Header, {
    titleId: titleId,
    title: title,
    onClose: handleOnClose
  }), /*#__PURE__*/React.createElement("section", {
    id: descriptionId
  }, children), (primaryButton || secondaryButton || tertiaryButton) && /*#__PURE__*/React.createElement(Footer, {
    primaryButton: primaryButtonWithIcon,
    secondaryButton: secondaryButton,
    tertiaryButton: tertiaryButton
  })));
};
Modal.displayName = 'Modal';