import _styled from "styled-components";
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import React from 'react';
import styled from 'styled-components';
import { Modal } from './index';
import { StyledMain } from './partials/StyledMain';
import { StyledModal } from './partials/StyledModal';
import { BUTTON_VARIANT } from '../Button';
export default {
  component: Modal,
  title: 'Modal',
  parameters: {
    actions: {
      argTypesRegex: '^on.*'
    },
    layout: 'fullscreen',
    jsx: {
      showFunctions: true
    }
  }
};
var primaryButton = {
  // eslint-disable-next-line @typescript-eslint/no-empty-function
  onClick: function onClick() {},
  children: 'Primary'
};
var secondaryButton = {
  // eslint-disable-next-line @typescript-eslint/no-empty-function
  onClick: function onClick() {},
  children: 'Secondary'
};
var tertiaryButton = {
  // eslint-disable-next-line @typescript-eslint/no-empty-function
  onClick: function onClick() {},
  children: 'Tertiary'
};
var Wrapper = styled.div.withConfig({
  displayName: "Modalstories__Wrapper",
  componentId: "sc-1iguh2x-0"
})(["height:", ";", "{position:absolute;z-index:1;", "{position:absolute;}}"], function (_ref) {
  var $height = _ref.$height;
  return $height;
}, StyledModal, StyledMain);
var Template = function Template(args) {
  return /*#__PURE__*/React.createElement(Wrapper, {
    $height: args.title && args.primaryButton ? '17rem' : '12rem'
  }, /*#__PURE__*/React.createElement(Modal, args, /*#__PURE__*/React.createElement(_StyledPre, null, "Arbitrary JSX content")));
};
export var Default = Template.bind({});
Default.args = {
  titleId: undefined,
  descriptionId: undefined,
  title: 'Example Title',
  isOpen: true,
  primaryButton: primaryButton,
  secondaryButton: secondaryButton,
  tertiaryButton: tertiaryButton
};
export var NoHeader = Template.bind({});
NoHeader.args = {
  isOpen: true,
  'aria-label': 'Modal with no header',
  primaryButton: primaryButton,
  secondaryButton: secondaryButton,
  tertiaryButton: tertiaryButton
};
NoHeader.storyName = 'No header';
export var NoButtons = Template.bind({});
NoButtons.args = {
  title: 'Example Title',
  isOpen: true
};
NoButtons.storyName = 'No buttons';
export var DangerButton = Template.bind({});
DangerButton.args = {
  isOpen: true,
  title: 'Example Title',
  primaryButton: _objectSpread(_objectSpread({}, primaryButton), {}, {
    variant: BUTTON_VARIANT.DANGER,
    icon: undefined
  }),
  secondaryButton: secondaryButton
};
DangerButton.storyName = 'Danger button with no icon';
export var NoTertiaryButton = Template.bind({});
NoTertiaryButton.args = {
  title: 'Example Title',
  isOpen: true,
  primaryButton: primaryButton,
  secondaryButton: secondaryButton
};
NoTertiaryButton.storyName = 'No tertiary button';
export var Blank = Template.bind({});
Blank.args = {
  isOpen: true,
  'aria-label': 'Blank modal'
};
Blank.storyName = 'Blank';
var _StyledPre = styled("pre").withConfig({
  displayName: "Modalstories___StyledPre",
  componentId: "sc-1iguh2x-1"
})({
  padding: '1rem'
});