var _excluded = ["hasFocus", "isDisabled", "id", "label", "size", "step", "value", "onChange"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React from 'react';
import { isNil } from 'lodash';
import { StyledInput } from '../TextInput/partials/StyledInput';
import { StyledInputWrapper } from './partials/StyledInputWrapper';
import { StyledLabel } from '../TextInput/partials/StyledLabel';
import { useInputKeys } from './useInputKeys';
export var Input = function Input(_ref) {
  var hasFocus = _ref.hasFocus,
    isDisabled = _ref.isDisabled,
    id = _ref.id,
    label = _ref.label,
    size = _ref.size,
    step = _ref.step,
    value = _ref.value,
    onChange = _ref.onChange,
    rest = _objectWithoutProperties(_ref, _excluded);
  var hasLabel = !!(label && label.length);
  var _useInputKeys = useInputKeys(step, onChange),
    handleKeyDown = _useInputKeys.handleKeyDown;
  return /*#__PURE__*/React.createElement(StyledInputWrapper, null, hasLabel && /*#__PURE__*/React.createElement(StyledLabel, {
    $hasContent: !isNil(value),
    $hasFocus: hasFocus,
    $size: size,
    htmlFor: id
  }, label), /*#__PURE__*/React.createElement(StyledInput, _extends({
    $hasLabel: hasLabel,
    $size: size,
    disabled: isDisabled,
    id: id,
    value: value || '',
    onKeyDown: handleKeyDown,
    onChange: onChange
  }, rest)));
};
Input.displayName = 'Input';