function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0) { ; } } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React, { useState } from 'react';
import { StyledHandleWrapper } from './partials/StyledHandleWrapper';
import { StyledHandle } from './partials/StyledHandle';
import { StyledValue } from './partials/StyledValue';
export var Handle = /*#__PURE__*/React.forwardRef(function (_ref, ref) {
  var _ref$domain = _slicedToArray(_ref.domain, 2),
    min = _ref$domain[0],
    max = _ref$domain[1],
    _ref$handle = _ref.handle,
    id = _ref$handle.id,
    value = _ref$handle.value,
    percent = _ref$handle.percent,
    getHandleProps = _ref.getHandleProps,
    formatValue = _ref.formatValue;
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    hasFocus = _useState2[0],
    setHasFocus = _useState2[1];
  var positionBag = {
    value: value,
    percentage: percent
  };
  return /*#__PURE__*/React.createElement(StyledHandleWrapper, _extends({
    $left: "".concat(percent, "%"),
    $hasFocus: hasFocus
  }, getHandleProps(id)), /*#__PURE__*/React.createElement(StyledHandle, {
    ref: ref,
    tabIndex: 0,
    role: "slider",
    "aria-label": "Select range",
    "aria-valuemin": min,
    "aria-valuemax": max,
    "aria-valuenow": value,
    onFocus: function onFocus(_) {
      return setHasFocus(true);
    },
    onBlur: function onBlur(_) {
      return setHasFocus(false);
    }
  }), /*#__PURE__*/React.createElement(StyledValue, {
    onMouseDown: function onMouseDown(_) {
      var _current;
      return (_current = ref.current) === null || _current === void 0 ? void 0 : _current.focus();
    }
  }, formatValue(positionBag)));
});
Handle.displayName = 'Handle';