var _excluded = ["children", "hasLabelFocus", "hasSelectedItem", "id", "inputProps", "inputWrapperProps", "isDisabled", "isInvalid", "isOpen", "hideClearButton", "label", "menuProps", "onClearButtonClick", "toggleButtonProps", "tooltipText", "value"],
  _excluded2 = ["ref"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0) { ; } } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { useState } from 'react';
import mergeRefs from 'react-merge-refs';
import { ArrowButton } from '../Select/ArrowButton';
import { ClearButton } from '../Select/ClearButton';
import { StyledInlineButtons } from './partials/StyledInlineButtons';
import { StyledInput } from './partials/StyledInput';
import { StyledInputWrapper } from './partials/StyledInputWrapper';
import { StyledLabel } from '../TextInput/partials/StyledLabel';
import { StyledOptions } from './partials/StyledOptions';
import { StyledOptionsWrapper } from './partials/StyledOptionsWrapper';
import { StyledOuterWrapper } from './partials/StyledOuterWrapper';
import { StyledSelect } from './partials/StyledSelect';
import { StyledTextInput } from './partials/StyledTextInput';
import { StyledTooltip } from './partials/StyledTooltip';
import { useExternalId } from '../../hooks/useExternalId';
import { useStatefulRef } from '../../hooks/useStatefulRef';
import { StyledFloatingBox } from './partials/StyledFloatingBox';
var isEllipsisActive = function isEllipsisActive(el) {
  return Boolean(el && el.offsetWidth < el.scrollWidth);
};
export var SelectLayout = function SelectLayout(_ref) {
  var children = _ref.children,
    _ref$hasLabelFocus = _ref.hasLabelFocus,
    hasLabelFocus = _ref$hasLabelFocus === void 0 ? false : _ref$hasLabelFocus,
    hasSelectedItem = _ref.hasSelectedItem,
    id = _ref.id,
    inputProps = _ref.inputProps,
    inputWrapperProps = _ref.inputWrapperProps,
    _ref$isDisabled = _ref.isDisabled,
    isDisabled = _ref$isDisabled === void 0 ? false : _ref$isDisabled,
    isInvalid = _ref.isInvalid,
    isOpen = _ref.isOpen,
    hideClearButton = _ref.hideClearButton,
    label = _ref.label,
    menuProps = _ref.menuProps,
    onClearButtonClick = _ref.onClearButtonClick,
    toggleButtonProps = _ref.toggleButtonProps,
    tooltipText = _ref.tooltipText,
    value = _ref.value,
    rest = _objectWithoutProperties(_ref, _excluded);
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    hasHover = _useState2[0],
    setHasHover = _useState2[1];
  var labelId = useExternalId('label');
  var _useStatefulRef = useStatefulRef(),
    _useStatefulRef2 = _slicedToArray(_useStatefulRef, 2),
    floatingBoxTarget = _useStatefulRef2[0],
    setFloatingBoxTarget = _useStatefulRef2[1];
  var ref = inputProps.ref,
    inputPropsRest = _objectWithoutProperties(inputProps, _excluded2);
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(StyledSelect, {
    "aria-labelledby": labelId
  }, /*#__PURE__*/React.createElement(StyledTextInput, null, /*#__PURE__*/React.createElement(StyledOuterWrapper, {
    $hasFocus: isOpen,
    $isDisabled: isDisabled,
    $isInvalid: isInvalid
  }, /*#__PURE__*/React.createElement(StyledInputWrapper, inputWrapperProps, /*#__PURE__*/React.createElement(StyledLabel, {
    $hasContent: hasSelectedItem,
    $hasFocus: hasLabelFocus,
    htmlFor: id,
    id: labelId
  }, label), /*#__PURE__*/React.createElement(StyledInput, _extends({
    ref: mergeRefs([setFloatingBoxTarget, ref]),
    $hasLabel: true,
    disabled: isDisabled,
    value: value,
    onMouseEnter: function onMouseEnter() {
      if (!isDisabled) {
        setHasHover(true);
      }
    },
    onMouseLeave: function onMouseLeave() {
      return setHasHover(false);
    }
  }, rest, inputPropsRest, {
    "aria-labelledby": labelId,
    id: id
  }))), /*#__PURE__*/React.createElement(StyledInlineButtons, null, hasSelectedItem && !hideClearButton && /*#__PURE__*/React.createElement(ClearButton, {
    isDisabled: isDisabled,
    onClick: onClearButtonClick
  }), /*#__PURE__*/React.createElement(ArrowButton, _extends({
    hasHover: hasHover,
    isDisabled: isDisabled,
    isOpen: isOpen
  }, toggleButtonProps))))), /*#__PURE__*/React.createElement(StyledOptionsWrapper, {
    $isVisible: isOpen
  }, /*#__PURE__*/React.createElement(StyledOptions, _extends({}, menuProps, {
    "aria-labelledby": labelId
  }), children))), /*#__PURE__*/React.createElement(StyledFloatingBox, {
    placement: "bottom",
    scheme: "dark",
    isVisible: hasHover && Boolean(tooltipText) && isEllipsisActive(floatingBoxTarget),
    targetElement: floatingBoxTarget
  }, /*#__PURE__*/React.createElement(StyledTooltip, null, tooltipText)));
};
SelectLayout.displayName = 'SelectLayout';