function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["data", "caption", "children", "className"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React from 'react';
import { useTableData } from './useTableData';
import { StyledTableWrapper } from './partials/StyledTableWrapper';
import { StyledTable } from './partials/StyledTable';
import { StyledTableHead } from './partials/StyledTableHead';
import { StyledTableRow } from './partials/StyledTableRow';
import { StyledTableCell } from './partials/StyledTableCell';
function getKey(prefix, id) {
  return "".concat(prefix, "_").concat(id);
}
export var Table = function Table(_ref) {
  var data = _ref.data,
    caption = _ref.caption,
    children = _ref.children,
    className = _ref.className,
    rest = _objectWithoutProperties(_ref, _excluded);
  var _useTableData = useTableData(data),
    tableData = _useTableData.tableData,
    sortTableData = _useTableData.sortTableData,
    sortField = _useTableData.sortField,
    sortOrder = _useTableData.sortOrder;
  var childrenWithSort = React.Children.map(children, function (child) {
    return /*#__PURE__*/React.cloneElement(child, _objectSpread(_objectSpread({}, child.props), {}, {
      sortOrder: sortField === child.props.field ? sortOrder : undefined,
      onSortClick: sortTableData
    }));
  });
  return /*#__PURE__*/React.createElement(StyledTableWrapper, {
    className: className
  }, /*#__PURE__*/React.createElement(StyledTable, _extends({
    role: "grid"
  }, rest), caption && /*#__PURE__*/React.createElement("caption", null, caption), /*#__PURE__*/React.createElement(StyledTableHead, null, /*#__PURE__*/React.createElement(StyledTableRow, null, childrenWithSort)), /*#__PURE__*/React.createElement("tbody", null, tableData.map(function (row) {
    return /*#__PURE__*/React.createElement(StyledTableRow, {
      key: getKey("table-row", row.id)
    }, React.Children.map(children, function (child) {
      return /*#__PURE__*/React.createElement(StyledTableCell, {
        key: getKey("table-cell-".concat(child.props.field), row.id)
      }, row[child.props.field]);
    }));
  }))));
};