function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0) { ; } } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { useEffect, useState } from 'react';
import orderBy from 'lodash/orderBy';
import { TABLE_SORT_ORDER } from '.';
function getNextSortOrder(currentSortOrder, hasSortFieldChanged) {
  if (!currentSortOrder || hasSortFieldChanged) {
    return TABLE_SORT_ORDER.DESCENDING;
  }
  if (currentSortOrder === TABLE_SORT_ORDER.DESCENDING) {
    return TABLE_SORT_ORDER.ASCENDING;
  }
  return null;
}
export function useTableData(data) {
  var _useState = useState(data),
    _useState2 = _slicedToArray(_useState, 2),
    tableData = _useState2[0],
    setTableData = _useState2[1];
  var _useState3 = useState(null),
    _useState4 = _slicedToArray(_useState3, 2),
    sortOrder = _useState4[0],
    setSortOrder = _useState4[1];
  var _useState5 = useState(null),
    _useState6 = _slicedToArray(_useState5, 2),
    sortField = _useState6[0],
    setSortField = _useState6[1];
  function sortTableData(field) {
    var hasSortFieldChanged = field !== sortField;
    var order = getNextSortOrder(sortOrder, hasSortFieldChanged);
    var sorted = order ? orderBy(tableData, [field], [order]) : data;
    setSortOrder(order);
    setSortField(field);
    setTableData(sorted);
  }
  useEffect(function () {
    setTableData(data);
  }, [data]);
  return {
    tableData: tableData,
    sortOrder: sortOrder,
    sortField: sortField,
    sortTableData: sortTableData
  };
}