var _excluded = ["className", "endAdornment", "isDisabled", "isInvalid", "onBlur", "startAdornment"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { memo } from 'react';
import { Input } from './Input';
import { StyledAdornment } from './partials/StyledAdornment';
import { StyledInputWrapper } from './partials/StyledInputWrapper';
import { StyledOuterWrapper } from './partials/StyledOuterWrapper';
import { StyledTextInput } from './partials/StyledTextInput';
import { useFocus } from '../../hooks/useFocus';
var Component = /*#__PURE__*/React.forwardRef(function (_ref, ref) {
  var className = _ref.className,
    endAdornment = _ref.endAdornment,
    isDisabled = _ref.isDisabled,
    isInvalid = _ref.isInvalid,
    onBlur = _ref.onBlur,
    startAdornment = _ref.startAdornment,
    rest = _objectWithoutProperties(_ref, _excluded);
  var _useFocus = useFocus(onBlur),
    hasFocus = _useFocus.hasFocus,
    onLocalBlur = _useFocus.onLocalBlur,
    onLocalFocus = _useFocus.onLocalFocus;
  return /*#__PURE__*/React.createElement(StyledTextInput, {
    className: className
  }, /*#__PURE__*/React.createElement(StyledOuterWrapper, {
    $hasFocus: hasFocus,
    $isDisabled: isDisabled,
    $isInvalid: isInvalid
  }, startAdornment && /*#__PURE__*/React.createElement(StyledAdornment, {
    $position: "start"
  }, startAdornment), /*#__PURE__*/React.createElement(StyledInputWrapper, null, /*#__PURE__*/React.createElement(Input, _extends({
    ref: ref,
    hasFocus: hasFocus,
    isDisabled: isDisabled,
    onBlur: onLocalBlur,
    onFocus: onLocalFocus
  }, rest))), endAdornment && /*#__PURE__*/React.createElement(StyledAdornment, {
    $position: "end"
  }, endAdornment)));
});
export var TextInput = /*#__PURE__*/memo(Component);
TextInput.displayName = 'TextInput';
// TextInput.whyDidYouRender = true