function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["barColor", "children", "endDate", "render", "startDate"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React from 'react';
import { format } from 'date-fns';
import { isString } from 'lodash';
import { ACCESSIBLE_DATE_FORMAT } from './constants';
import { DATE_FORMAT } from '../../constants';
import { StyledEvent } from './partials/StyledEvent';
import { StyledEventBar } from './partials/StyledEventBar';
import { StyledEventTitle } from './partials/StyledEventTitle';
import { useTimelinePosition } from './hooks/useTimelinePosition';
function renderDefault(_ref) {
  var barColor = _ref.barColor,
    children = _ref.children,
    offsetPx = _ref.offsetPx,
    startDate = _ref.startDate,
    widthPx = _ref.widthPx,
    maxWidthPx = _ref.maxWidthPx,
    startsBeforeStart = _ref.startsBeforeStart,
    endsAfterEnd = _ref.endsAfterEnd;
  return /*#__PURE__*/React.createElement(StyledEvent, {
    $leftPx: offsetPx
  }, /*#__PURE__*/React.createElement(StyledEventBar, {
    $barColor: barColor,
    $width: widthPx,
    $maxWidth: maxWidthPx,
    $startsBeforeStart: startsBeforeStart,
    $endsAfterEnd: endsAfterEnd
  }), /*#__PURE__*/React.createElement(StyledEventTitle, null, children || "Task ".concat(format(new Date(startDate), DATE_FORMAT.SHORT))));
}
function getTitle(children, startDate, endDate) {
  var start = isString(children) ? "".concat(children, " begins") : "Begins";
  return "".concat(start, " on ").concat(format(startDate, ACCESSIBLE_DATE_FORMAT), " and ends on ").concat(format(endDate, ACCESSIBLE_DATE_FORMAT));
}
export var TimelineEvent = function TimelineEvent(_ref2) {
  var barColor = _ref2.barColor,
    children = _ref2.children,
    endDate = _ref2.endDate,
    render = _ref2.render,
    startDate = _ref2.startDate,
    rest = _objectWithoutProperties(_ref2, _excluded);
  var _useTimelinePosition = useTimelinePosition(startDate, endDate),
    startsBeforeStart = _useTimelinePosition.startsBeforeStart,
    startsAfterEnd = _useTimelinePosition.startsAfterEnd,
    endsBeforeStart = _useTimelinePosition.endsBeforeStart,
    endsAfterEnd = _useTimelinePosition.endsAfterEnd,
    offsetPx = _useTimelinePosition.offset,
    widthPx = _useTimelinePosition.width,
    maxWidthPx = _useTimelinePosition.maxWidth;
  if (startsAfterEnd || endsBeforeStart) {
    return null;
  }
  var event = render ? render({
    startDate: startDate,
    endDate: endDate,
    widthPx: widthPx,
    offsetPx: offsetPx,
    maxWidthPx: maxWidthPx,
    startsBeforeStart: startsBeforeStart,
    endsAfterEnd: endsAfterEnd
  }) : renderDefault({
    barColor: barColor,
    children: children,
    offsetPx: offsetPx,
    startDate: startDate,
    widthPx: widthPx,
    maxWidthPx: maxWidthPx,
    startsBeforeStart: startsBeforeStart,
    endsAfterEnd: endsAfterEnd
  });
  var title = getTitle(children, startDate, endDate);
  return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.cloneElement(event, _objectSpread({
    title: title,
    'aria-label': title,
    role: 'cell'
  }, rest)));
};
TimelineEvent.displayName = 'TimelineEvent';