var _excluded = ["days", "daysTotal", "dayWidth", "index", "render", "size", "startDate"];
var _MONTHS_BY_SIZE;
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import React from 'react';
import { format } from 'date-fns';
import { DATE_MONTH_FORMAT } from './constants';
import { StyledMonth } from './partials/StyledMonth';
import { StyledMonthMedium } from './partials/StyledMonthMedium';
import { StyledMonthSmall } from './partials/StyledMonthSmall';
import { StyledMonthTitle } from './partials/StyledMonthTitle';
import { StyledMonthTitleMedium } from './partials/StyledMonthTitleMedium';
import { StyledMonthTitleSmall } from './partials/StyledMonthTitleSmall';
var DECEMBER_INDEX = 11;
export var MONTH_SIZE = {
  SMALL: 'small',
  MEDIUM: 'medium',
  LARGE: 'large'
};
var MONTHS_BY_SIZE = (_MONTHS_BY_SIZE = {}, _defineProperty(_MONTHS_BY_SIZE, MONTH_SIZE.SMALL, function (startDate, width) {
  return /*#__PURE__*/React.createElement(StyledMonthSmall, {
    $hasThickBorder: startDate.getMonth() === DECEMBER_INDEX,
    $width: width
  }, /*#__PURE__*/React.createElement(StyledMonthTitleSmall, null, format(startDate, 'MMM'), " ", format(startDate, 'yyyy')));
}), _defineProperty(_MONTHS_BY_SIZE, MONTH_SIZE.MEDIUM, function (startDate, width) {
  return /*#__PURE__*/React.createElement(StyledMonthMedium, {
    $width: width
  }, /*#__PURE__*/React.createElement(StyledMonthTitleMedium, null, /*#__PURE__*/React.createElement("span", null, format(startDate, 'MMM')), /*#__PURE__*/React.createElement("span", null, format(startDate, 'yyyy'))));
}), _defineProperty(_MONTHS_BY_SIZE, MONTH_SIZE.LARGE, function (startDate, width) {
  return /*#__PURE__*/React.createElement(StyledMonth, {
    $width: width
  }, /*#__PURE__*/React.createElement(StyledMonthTitle, null, format(startDate, DATE_MONTH_FORMAT)));
}), _MONTHS_BY_SIZE);
function renderDefault(_ref) {
  var dayWidth = _ref.dayWidth,
    daysTotal = _ref.daysTotal,
    size = _ref.size,
    startDate = _ref.startDate;
  var width = dayWidth * daysTotal;
  return MONTHS_BY_SIZE[size](startDate, width);
}
export var TimelineMonth = function TimelineMonth(_ref2) {
  var _ = _ref2.days,
    daysTotal = _ref2.daysTotal,
    dayWidth = _ref2.dayWidth,
    index = _ref2.index,
    render = _ref2.render,
    size = _ref2.size,
    startDate = _ref2.startDate,
    rest = _objectWithoutProperties(_ref2, _excluded);
  var child = render ? render({
    index: index,
    dayWidth: dayWidth,
    daysTotal: daysTotal,
    startDate: startDate
  }) : renderDefault({
    dayWidth: dayWidth,
    daysTotal: daysTotal,
    size: size,
    startDate: startDate
  });
  return /*#__PURE__*/React.cloneElement(child, _objectSpread({
    role: 'columnheader'
  }, rest));
};
TimelineMonth.displayName = 'TimelineMonth';