var _excluded = ["render"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { memo, useContext } from 'react';
import { getKey } from '../../helpers';
import { StyledWeeks } from './partials/StyledWeeks';
import { TimelineContext } from './context';
import { TimelineHeaderRow } from './TimelineHeaderRow';
import { TimelineWeek } from './TimelineWeek';
import { DISPLAY_THRESHOLDS } from './constants';
import { TimelineColumnHeader } from './TimelineColumnHeader';
export var TimelineWeeks = /*#__PURE__*/memo(function (_ref) {
  var render = _ref.render,
    rest = _objectWithoutProperties(_ref, _excluded);
  var _useContext = useContext(TimelineContext),
    _useContext$state = _useContext.state,
    currentScaleOption = _useContext$state.currentScaleOption,
    days = _useContext$state.days,
    weeks = _useContext$state.weeks;
  if (!currentScaleOption) {
    return null;
  }
  var isBelowThreshold = currentScaleOption.widths.day * 7 < DISPLAY_THRESHOLDS.WEEK;
  var rowChildren = isBelowThreshold ? /*#__PURE__*/React.createElement(TimelineColumnHeader, {
    name: "No weeks"
  }) : /*#__PURE__*/React.createElement(StyledWeeks, null, weeks.map(function (_ref2, index) {
    var startDate = _ref2.startDate;
    return /*#__PURE__*/React.createElement(TimelineWeek, {
      days: days,
      dayWidth: currentScaleOption.widths.day,
      index: index,
      key: getKey('timeline-week', startDate.toString()),
      render: render,
      startDate: startDate
    });
  }));
  return /*#__PURE__*/React.createElement(TimelineHeaderRow, _extends({
    className: "timeline__weeks",
    isShort: true,
    name: "Weeks"
  }, rest), rowChildren);
});
TimelineWeeks.displayName = 'TimelineWeeks';