var _excluded = ["label", "children", "onDismiss", "appearance", "placement", "transitionDuration", "transitionState", "dateTime"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0) { ; } } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { useState } from 'react';
import { IconInfo, IconWarning, IconError, IconCheckCircle } from '@defencedigital/icon-library';
import { StyledToast } from './partials/StyledToast';
import { StyledToastHeader } from './partials/StyledToastHeader';
import { StyledToastTitle } from './partials/StyledToastTitle';
import { StyledToastLabel } from './partials/StyledToastLabel';
import { StyledToastTime } from './partials/StyledToastTime';
import { StyledToastButton } from './partials/StyledToastButton';
import { StyledToastContent } from './partials/StyledToastContent';
import { StyledToastDescription } from './partials/StyledToastDescription';
import { useExternalId } from '../../hooks/useExternalId';
function getAppearanceIcon(appearance) {
  var appearanceIconMap = {
    success: /*#__PURE__*/React.createElement(IconCheckCircle, {
      "aria-hidden": true
    }),
    error: /*#__PURE__*/React.createElement(IconError, {
      "aria-hidden": true
    }),
    warning: /*#__PURE__*/React.createElement(IconWarning, {
      "aria-hidden": true
    }),
    info: /*#__PURE__*/React.createElement(IconInfo, {
      "aria-hidden": true
    })
  };
  return appearanceIconMap[appearance] || appearanceIconMap.info;
}
export var Toast = function Toast(_ref) {
  var label = _ref.label,
    children = _ref.children,
    onDismiss = _ref.onDismiss,
    appearance = _ref.appearance,
    placement = _ref.placement,
    transitionDuration = _ref.transitionDuration,
    transitionState = _ref.transitionState,
    dateTime = _ref.dateTime,
    rest = _objectWithoutProperties(_ref, _excluded);
  var _useState = useState((dateTime || new Date()).toLocaleTimeString('en-GB', {
      hour: 'numeric',
      minute: 'numeric',
      hour12: true
    })),
    _useState2 = _slicedToArray(_useState, 1),
    time = _useState2[0];
  var titleId = useExternalId('toast-title');
  var descriptionId = useExternalId('toast-description');
  return /*#__PURE__*/React.createElement(StyledToast, _extends({
    $appearance: appearance,
    $placement: placement,
    $transitionState: transitionState,
    $transitionDuration: transitionDuration,
    role: "alert",
    "aria-labelledby": label ? titleId : undefined,
    "aria-describedby": children ? descriptionId : undefined
  }, rest), /*#__PURE__*/React.createElement(StyledToastHeader, null, /*#__PURE__*/React.createElement(StyledToastTitle, {
    id: titleId
  }, /*#__PURE__*/React.createElement(StyledToastLabel, null, getAppearanceIcon(appearance), label), /*#__PURE__*/React.createElement(StyledToastTime, null, time)), onDismiss && /*#__PURE__*/React.createElement(StyledToastButton, {
    onClick: function onClick(_) {
      return onDismiss();
    }
  }, "Dismiss")), /*#__PURE__*/React.createElement(StyledToastContent, null, /*#__PURE__*/React.createElement(StyledToastDescription, {
    id: descriptionId
  }, children)));
};
Toast.displayName = 'Toast';