function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["link", "name", "isRead", "action", "on", "when", "description"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React from 'react';
import differenceInMinutes from 'date-fns/differenceInMinutes';
import formatDistanceStrict from 'date-fns/formatDistanceStrict';
import format from 'date-fns/format';
import { Avatar, AVATAR_VARIANT } from '../../Avatar';
import { getInitials } from '../../../helpers';
import { StyledNotification } from './partials/StyledNotification';
import { StyledWrapper } from './partials/StyledWrapper';
import { StyledItem } from './partials/StyledItem';
import { StyledAvatar } from './partials/StyledAvatar';
import { StyledItemNotRead } from './partials/StyledItemNotRead';
import { StyledContent } from './partials/StyledContent';
import { StyledCircle } from './partials/StyledCircle';
import { StyledDescription } from './partials/StyledDescription';
import { useExternalId } from '../../../hooks/useExternalId';
function formatWhen(when) {
  var now = Date.now();
  var minutesInDay = 1440;
  if (differenceInMinutes(now, when) < 5) {
    return 'Just now';
  }
  if (differenceInMinutes(now, when) < minutesInDay) {
    return "".concat(formatDistanceStrict(now, when), " ago");
  }
  return format(when, 'dd MMM yyyy');
}
export var Notification = function Notification(_ref) {
  var link = _ref.link,
    name = _ref.name,
    isRead = _ref.isRead,
    action = _ref.action,
    on = _ref.on,
    when = _ref.when,
    description = _ref.description,
    rest = _objectWithoutProperties(_ref, _excluded);
  var contentId = useExternalId('content');
  return /*#__PURE__*/React.createElement(StyledNotification, rest, /*#__PURE__*/React.createElement(StyledWrapper, null, /*#__PURE__*/React.cloneElement(link, _objectSpread(_objectSpread({}, link.props), {}, {
    children: /*#__PURE__*/React.createElement(StyledItem, {
      "aria-describedby": contentId
    }, /*#__PURE__*/React.createElement(StyledAvatar, null, /*#__PURE__*/React.createElement(Avatar, {
      variant: AVATAR_VARIANT.DARK,
      "aria-hidden": true
    }, getInitials(name)), !isRead && /*#__PURE__*/React.createElement(StyledItemNotRead, {
      title: "Unread"
    })), /*#__PURE__*/React.createElement(StyledContent, {
      id: contentId
    }, /*#__PURE__*/React.createElement("strong", null, name), " ".concat(action, " "), /*#__PURE__*/React.createElement("strong", null, on), /*#__PURE__*/React.createElement(StyledCircle, null), /*#__PURE__*/React.createElement("span", null, formatWhen(when)), /*#__PURE__*/React.createElement(StyledDescription, null, description.substring(0, 38), "...")))
  }))));
};