function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["button", "children", "placement", "closeDelay", "id", "initialIsOpen"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React from 'react';
import { FLOATING_BOX_PLACEMENT, FloatingBox } from '../../../primitives/FloatingBox';
import { useExternalId } from '../../../hooks/useExternalId';
import { useHideShow } from '../../../hooks/useHideShow';
export var Sheet = function Sheet(_ref) {
  var button = _ref.button,
    children = _ref.children,
    _ref$placement = _ref.placement,
    placement = _ref$placement === void 0 ? FLOATING_BOX_PLACEMENT.RIGHT : _ref$placement,
    _ref$closeDelay = _ref.closeDelay,
    closeDelay = _ref$closeDelay === void 0 ? 250 : _ref$closeDelay,
    externalId = _ref.id,
    _ref$initialIsOpen = _ref.initialIsOpen,
    initialIsOpen = _ref$initialIsOpen === void 0 ? false : _ref$initialIsOpen,
    rest = _objectWithoutProperties(_ref, _excluded);
  var id = useExternalId('sheet', externalId);
  var _useHideShow = useHideShow(true, closeDelay, initialIsOpen),
    floatingBoxChildrenRef = _useHideShow.floatingBoxChildrenRef,
    isVisible = _useHideShow.isVisible,
    mouseEvents = _useHideShow.mouseEvents;
  var SheetTarget = function SheetTarget() {
    return /*#__PURE__*/React.cloneElement(button, _objectSpread(_objectSpread(_objectSpread({}, button.props), mouseEvents), {}, {
      'aria-expanded': isVisible,
      'aria-owns': id
    }));
  };
  return /*#__PURE__*/React.createElement(FloatingBox, _extends({
    isVisible: isVisible,
    placement: placement,
    renderTarget: /*#__PURE__*/React.createElement(SheetTarget, null),
    scheme: "dark"
  }, rest), /*#__PURE__*/React.createElement("div", {
    ref: floatingBoxChildrenRef
  }, /*#__PURE__*/React.cloneElement(children, {
    id: id
  })));
};
Sheet.displayName = 'Sheet';