var _excluded = ["transitionStatus"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { useContext, forwardRef } from 'react';
import { IconChevronLeft, IconChevronRight } from '@defencedigital/icon-library';
import { SidebarContext } from './context';
import { StyledHandle } from './partials/StyledHandle';
export var SidebarHandle = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var transitionStatus = _ref.transitionStatus,
    rest = _objectWithoutProperties(_ref, _excluded);
  var _useContext = useContext(SidebarContext),
    isOpen = _useContext.isOpen,
    setIsOpen = _useContext.setIsOpen;
  var handleClick = function handleClick(e) {
    e.preventDefault();
    setIsOpen(!isOpen);
  };
  return /*#__PURE__*/React.createElement(StyledHandle, _extends({
    ref: ref,
    onClick: handleClick,
    "aria-label": "".concat(isOpen ? 'Collapse' : 'Expand', " sidebar"),
    $transitionStatus: transitionStatus
  }, rest), isOpen ? /*#__PURE__*/React.createElement(IconChevronLeft, null) : /*#__PURE__*/React.createElement(IconChevronRight, null));
});
SidebarHandle.displayName = 'SidebarHandle';