import React from 'react';
import { ALERT_VARIANT } from './constants';
import { ValueOf } from '../../helpers';
export type AlertVariantType = ValueOf<typeof ALERT_VARIANT>;
export interface AlertProps {
    /**
     * Description text to display under the component title.
     */
    children: string;
    /**
     * Optional handler to be invoked when the component is closed.
     */
    onClose?: (event: React.FormEvent<HTMLButtonElement>) => void;
    /**
     * Optional title to display above the description text.
     */
    title?: string;
    /**
     * Type of component to display (style varies accordingly).
     */
    variant?: AlertVariantType;
}
export declare const Alert: React.FC<AlertProps>;
//# sourceMappingURL=Alert.d.ts.map