import React from 'react';
import { ComponentWithClass } from '../../common/ComponentWithClass';
import { BadgeColorType, BadgeColorVariantType, BadgeSizeType, BadgeVariantType } from './types';
export interface BadgeProps extends ComponentWithClass {
    /**
     * Color of the component (pre-defined design token values).
     */
    color?: BadgeColorType;
    /**
     * Whether to display using solid or faded colors.
     */
    colorVariant?: BadgeColorVariantType;
    /**
     * Size of the component.
     */
    size?: BadgeSizeType;
    /**
     * Type of component to display (style varies accordingly).
     */
    variant?: BadgeVariantType;
    /**
     * Text content to display within the badge.
     */
    children: React.ReactNode | React.ReactNode[];
}
export declare const Badge: React.FC<BadgeProps>;
//# sourceMappingURL=Badge.d.ts.map