import React from 'react';
import { LinkTypes } from '../../common/Link';
export interface BreadcrumbsItemBaseProps {
    /**
     * Denotes whether this is the first item.
     * @private
     */
    isFirst?: boolean;
    /**
     * Denotes whether this is the last item.
     * @private
     */
    isLast?: boolean;
}
export interface BreadcrumbsItemWithLinkProps extends BreadcrumbsItemBaseProps {
    /**
     * Optional Link component to use for the item (redundant if `href` is used).
     */
    link: React.ReactElement<LinkTypes>;
    href?: never;
}
export interface BreadcrumbsItemWithHrefProps extends BreadcrumbsItemBaseProps {
    /**
     * Optional `href` attribute to apply to HTML anchor (redundant if `link` is used).
     */
    href: string;
    link?: never;
}
export type BreadcrumbsItemProps = BreadcrumbsItemWithLinkProps | BreadcrumbsItemWithHrefProps;
export declare const BreadcrumbsItem: React.FC<BreadcrumbsItemProps>;
//# sourceMappingURL=BreadcrumbsItem.d.ts.map