import React, { FormEvent } from 'react';
import { ComponentSizeType } from '../Forms';
export interface ButtonGroupItemProps {
    /**
     * Text to display within the component.
     */
    children: string;
    /**
     * Toggles whether the component is disabled or not (preventing user interaction).
     */
    isDisabled?: boolean;
    /**
     * Optional icon to display beside the component text.
     */
    icon?: React.ReactNode;
    /**
     * Optional handler called when the component is clicked.
     */
    onClick?: (event: FormEvent<HTMLButtonElement>) => void;
    /**
     * Size of the component.
     */
    size?: ComponentSizeType;
}
export declare const ButtonGroupItem: React.FC<ButtonGroupItemProps>;
//# sourceMappingURL=ButtonGroupItem.d.ts.map