import React from 'react';
import { ComponentWithClass } from '../../common/ComponentWithClass';
import { ClickType } from '../../hooks/useClickMenu';
export interface ContextMenuProps extends ComponentWithClass {
    /**
     * A ref object for the element associated with the component.
     */
    attachedToRef: React.RefObject<HTMLElement>;
    /**
     * Should the menu display when the user uses a left or right mouse click.
     */
    clickType?: ClickType;
    /**
     * Toggles whether the menu is open on first render.
     */
    initialIsOpen?: boolean;
    /**
     * Optional handler function to be invoked when the component is hidden.
     */
    onHide?: (e: MouseEvent) => void;
    /**
     * Optional handler function to be invoked when the component is displayed.
     */
    onShow?: (e: MouseEvent) => void;
}
export declare const ContextMenu: React.FC<ContextMenuProps>;
//# sourceMappingURL=ContextMenu.d.ts.map