import React from 'react';
import { ComponentWithClass } from '../../common/ComponentWithClass';
import { DescriptionListItemProps } from '.';
export interface DescriptionListProps extends ComponentWithClass {
    /**
     * Collection of `DescriptionListItem` components to display in the list.
     */
    children: React.ReactElement<DescriptionListItemProps> | React.ReactElement<DescriptionListItemProps>[];
    /**
     * Toggles whether the list is collapsable via user input.
     */
    isCollapsible?: boolean;
    /**
     * Denotes whether the collapsible variant is open.
     */
    isOpen?: boolean;
    /**
     * Text description to display at the top of the component.
     */
    description: string;
}
export declare const DescriptionList: React.FC<DescriptionListProps>;
//# sourceMappingURL=DescriptionList.d.ts.map