import React from 'react';
import { ComponentWithClass } from '../../common/ComponentWithClass';
export interface DialogProps extends ComponentWithClass {
    /**
     * Optional override for the accessible name of the Modal.
     */
    'aria-label'?: string;
    /**
     * Optional text description to display under the component title.
     */
    description?: string;
    /**
     * Toggles whether to display the type of the component (style varies accordingly).
     */
    isDanger?: boolean;
    /**
     * Toggles whether the component is visible or hidden from view.
     */
    isOpen?: boolean;
    /**
     * Optional handler called when the Cancel button is clicked.
     */
    onCancel?: (event: React.FormEvent<HTMLButtonElement>) => void;
    /**
     * Optional handler called when the Confirm button is clicked.
     */
    onConfirm?: (event: React.FormEvent<HTMLButtonElement>) => void;
    /**
     * Optional text title to display at the top of the component.
     *
     * If no title is set, you should set aria-label instead to ensure
     * the Modal is accessible.
     */
    title?: string;
}
export declare const Dialog: React.FC<DialogProps>;
//# sourceMappingURL=Dialog.d.ts.map