import React from 'react';
import { ComponentWithClass } from '../../common/ComponentWithClass';
export interface DismissibleBannerWithTitleProps extends ComponentWithClass {
    /**
     * Toggles whether to display the 'Don't show this again' checkbox.
     */
    hasCheckbox?: boolean;
    /**
     * Description text to display in the main body of the component.
     */
    children: string;
    /**
     * Optional handler function to be invoked when the Dismiss button is clicked.
     */
    onDismiss?: (event: React.FormEvent<HTMLButtonElement>, canShowAgain: boolean) => void;
    /**
     * Optional text title to display at the top of the component.
     */
    title: string;
}
export interface DismissibleBannerWithArbitraryContentProps extends ComponentWithClass {
    /**
     * Toggles whether to display the 'Don't show this again' checkbox.
     */
    hasCheckbox?: boolean;
    /**
     * Arbitrary JSX content to display in the main body of the component.
     */
    children: React.ReactChild;
    /**
     * Optional handler function to be invoked when the Dismiss button is clicked.
     */
    onDismiss?: (event: React.FormEvent<HTMLButtonElement>, canShowAgain: boolean) => void;
    /**
     * Optional text title to display at the top of the component.
     */
    title?: never;
}
export type DismissibleBannerProps = DismissibleBannerWithTitleProps | DismissibleBannerWithArbitraryContentProps;
export declare const DismissibleBanner: React.FC<DismissibleBannerProps>;
//# sourceMappingURL=DismissibleBanner.d.ts.map