import React from 'react';
import { ComponentWithClass } from '../../common/ComponentWithClass';
export interface DrawerProps extends ComponentWithClass {
    /**
     * Arbitrary JSX content to display within the component.
     */
    children?: React.ReactNode;
    /**
     * Toggles whether the component is visible or hidden outside of the viewport.
     */
    isOpen?: boolean;
    /**
     * Optional handler called when the close button is clicked.
     */
    onClose?: (event: React.FormEvent<HTMLButtonElement>) => void;
}
export declare const Drawer: React.ForwardRefExoticComponent<DrawerProps & React.RefAttributes<HTMLDivElement>>;
//# sourceMappingURL=Drawer.d.ts.map