import React from 'react';
import { DropdownOption } from './DropdownOption';
export interface DropdownProps {
    /**
     * Toggles whether the list is open on first render.
     */
    initialIsOpen?: boolean;
    /**
     * Handler called when an option is clicked.
     */
    onSelect?: (value: string) => void;
    /**
     * Array of options to display within the component.
     */
    options: DropdownOption[];
    /**
     * Text label to display within the component.
     */
    label: string;
    /**
     * Optional icon component to display next to the label.
     */
    labelIcon?: React.ReactNode;
}
export declare const Dropdown: React.FC<DropdownProps>;
//# sourceMappingURL=Dropdown.d.ts.map