import React from 'react';
import { ComponentWithClass } from '../../common/ComponentWithClass';
export interface ListItemProps extends ComponentWithClass {
    /**
     * Description text to display for an individual item.
     */
    children: string | string[];
    /**
     * Toggles whether the item is in an active state.
     */
    isActive?: boolean;
    /**
     * Optional handler called when the item is clicked.
     */
    onClick?: (event: React.MouseEvent<HTMLButtonElement>) => void;
    /**
     * Optional handler called when the mouse enters the item area.
     */
    onMouseEnter?: (event: React.MouseEvent<HTMLButtonElement>) => void;
    /**
     * Optional handler called when the mouse leaves the item area.
     */
    onMouseLeave?: (event: React.MouseEvent<HTMLButtonElement>) => void;
    /**
     * Text title to display for an individual item.
     */
    title: string;
}
export declare const ListItem: React.FC<ListItemProps>;
//# sourceMappingURL=ListItem.d.ts.map