import React from 'react';
import { OnChangeEventType } from './types';
export interface PaginationProps {
    /**
     * Starting page to display from range on first render.
     */
    initialPage?: number;
    /**
     * Optional HTML `name` attribute to apply to the component (a11y).
     */
    name?: string;
    /**
     * Optional handler called when the value of currently selected page changes.
     */
    onChange?: (event: OnChangeEventType, currentPage: number, totalPages: number) => void;
    /**
     * Number of items within a paginated collection per page.
     */
    pageSize: number;
    /**
     * Total number of items within a paginated collection.
     */
    total: number;
}
export declare const Pagination: React.FC<PaginationProps>;
//# sourceMappingURL=Pagination.d.ts.map