import React from 'react';
import { Placement } from '@popperjs/core';
import { FloatingBoxProps, FloatingBoxSchemeType } from '../../primitives/FloatingBox';
export interface PopoverProps extends Omit<FloatingBoxProps, 'onMouseEnter' | 'onMouseLeave' | 'renderTarget' | 'targetElement'> {
    /**
     * JSX target element to attach the Popover to.
     */
    children: React.ReactElement;
    /**
     * Number of milliseconds (ms) before the component closes after mouse leave.
     */
    closeDelay?: number;
    /**
     * Arbitrary JSX content to display within the component.
     */
    content: React.ReactElement;
    /**
     * Toggles whether the Popover displays on click instead of mouse over.
     */
    isClick?: boolean;
    /**
     * Where to place the Popover relative to the target element.
     */
    placement?: Placement;
    /**
     * Type of component to display (style varies accordingly).
     */
    scheme?: FloatingBoxSchemeType;
}
export declare const Popover: React.FC<PopoverProps>;
//# sourceMappingURL=Popover.d.ts.map