import { UseSelectReturnValue, UseComboboxReturnValue } from 'downshift';
import React from 'react';
import { ComponentWithClass } from '../../common/ComponentWithClass';
import { SelectChildWithStringType } from './types';
type ComboboxReturnValueType = UseComboboxReturnValue<SelectChildWithStringType>;
type SelectReturnValueType = UseSelectReturnValue<SelectChildWithStringType>;
export interface SelectLayoutProps extends ComponentWithClass {
    hasLabelFocus?: boolean;
    hasSelectedItem: boolean;
    id: string;
    inputProps: ReturnType<ComboboxReturnValueType['getInputProps']>;
    inputWrapperProps?: ReturnType<ComboboxReturnValueType['getComboboxProps']>;
    isDisabled?: boolean;
    isInvalid?: boolean;
    isOpen: boolean;
    hideClearButton?: boolean;
    label: string;
    menuProps: ReturnType<ComboboxReturnValueType['getMenuProps']> | ReturnType<SelectReturnValueType['getMenuProps']>;
    onChange?: (value: string | null) => void;
    onClearButtonClick: (event: React.MouseEvent<HTMLButtonElement>) => void;
    toggleButtonProps: ReturnType<ComboboxReturnValueType['getToggleButtonProps']> | ReturnType<SelectReturnValueType['getToggleButtonProps']>;
    tooltipText: string;
    value?: string;
}
export declare const SelectLayout: React.FC<SelectLayoutProps>;
export {};
//# sourceMappingURL=SelectLayout.d.ts.map