import React from 'react';
import { SwitchOptionProps } from '.';
import { ComponentWithClass } from '../../common/ComponentWithClass';
import { InputValidationProps } from '../../common/InputValidationProps';
import { ComponentSizeType } from '../Forms';
export type SwitchChildType = React.ReactElement<SwitchOptionProps> | React.ReactFragment | false | null | undefined;
export interface SwitchProps extends ComponentWithClass, InputValidationProps {
    /**
     * HTML `name` attribute to apply to the component.
     */
    name: string;
    /**
     * Optional HTML `value` attribute to apply to the component.
     */
    value?: string;
    /**
     * Optional label to display as HTML legend.
     */
    label?: string;
    /**
     * Optional handler invoked when the selected value changes.
     */
    onChange?: (e: React.FormEvent<HTMLInputElement>) => void;
    /**
     * Size of the component.
     */
    size?: ComponentSizeType;
    /**
     * Toggles whether the component is disabled or not (preventing user interaction).
     */
    isDisabled?: boolean;
    /**
     * Collection of options to display within the Switch.
     */
    children: SwitchChildType | SwitchChildType[];
}
export declare const Switch: React.FC<SwitchProps>;
//# sourceMappingURL=Switch.d.ts.map