import React from 'react';
import { ComponentWithClass } from '../../common/ComponentWithClass';
export interface SwitchOptionProps extends ComponentWithClass {
    /**
     * Descriptive label associated with the selectable option.
     */
    label: string;
    /**
     * Value associated with the selectable option (not visible).
     */
    value: string;
    /**
     * Denotes whether this option is disabled or not.
     */
    isDisabled?: boolean;
    /**
     * Name attribute associated of the Switch.
     * @private
     */
    name?: string;
    /**
     * Unique ID associated with the Switch.
     * @private
     */
    id?: string;
    /**
     * Denotes whether this option is active or not.
     * @private
     */
    isActive?: boolean;
    /**
     * Handler invoked when the option is selected by end user.
     * @private
     */
    onChange?: (event: React.FormEvent<HTMLInputElement>) => void;
}
export declare const SwitchOption: React.FC<SwitchOptionProps>;
//# sourceMappingURL=SwitchOption.d.ts.map