import React, { KeyboardEvent, MouseEvent } from 'react';
import { ComponentWithClass } from '../../common/ComponentWithClass';
import { TabSetItemProps } from '.';
type OnChangeEventType = KeyboardEvent<HTMLLIElement> | KeyboardEvent<HTMLButtonElement> | MouseEvent<HTMLButtonElement>;
export interface TabSetProps extends ComponentWithClass {
    /**
     * Collection of `Tab` components that make up the tab set.
     */
    children: React.ReactElement<TabSetItemProps>[];
    /**
     * Optional handler invoked when the currently selected tab is changed.
     */
    onChange?: (e: OnChangeEventType, id: number) => void;
    /**
     * Toggles whether to display the tab set full width.
     */
    isFullWidth?: boolean;
    /**
     * Toggles whether to render the scrollable variant of the component.
     */
    isScrollable?: never;
}
export interface ScrollableTabSetProps extends ComponentWithClass {
    /**
     * Collection of `Tab` components that make up the tab set.
     */
    children: React.ReactElement<TabSetItemProps>[];
    /**
     * Optional handler invoked when the currently selected tab is changed.
     */
    onChange?: (e: OnChangeEventType, id: number) => void;
    /**
     * Toggles whether to display the tab set full width.
     */
    isFullWidth?: never;
    /**
     * Toggles whether to render the scrollable variant of the component.
     */
    isScrollable?: boolean;
}
export declare const TabSet: React.FC<TabSetProps | ScrollableTabSetProps>;
export {};
//# sourceMappingURL=TabSet.d.ts.map