import React from 'react';
import { TableColumnProps } from '.';
import { ComponentWithClass } from '../../common/ComponentWithClass';
export interface RowProps extends Record<string, unknown> {
    id: string;
}
export interface TableProps extends ComponentWithClass {
    /**
     * Data to display within the table (JSON).
     */
    data: RowProps[];
    /**
     * Collection of `TableColumn` components to describe column functionality.
     */
    children: React.ReactElement<TableColumnProps>[];
    /**
     * Optional text caption to display above the component.
     */
    caption?: string;
}
export declare const Table: React.FC<TableProps>;
//# sourceMappingURL=Table.d.ts.map