import React from 'react';
import { TABLE_SORT_ORDER } from './constants';
import { ValueOf } from '../../helpers';
export type SortOrderType = ValueOf<typeof TABLE_SORT_ORDER>;
export interface TableColumnProps {
    /**
     * Name of the column to display in the table head.
     */
    children: string;
    /**
     * Mapping of column to `field` key within supplied table data JSON.
     */
    field: string;
    /**
     * Toggle whether the column is sortable.
     */
    isSortable?: boolean;
    /**
     * Optional handler invoked when one of the column sort buttons is clicked.
     */
    onSortClick?: (field: string) => void;
    /**
     * Optional sort order by which to sort the column.
     */
    sortOrder?: SortOrderType | null;
}
export declare const TableColumn: React.FC<TableColumnProps>;
//# sourceMappingURL=TableColumn.d.ts.map