import React, { TextareaHTMLAttributes } from 'react';
import { ComponentWithClass } from '../../common/ComponentWithClass';
import { InputValidationProps } from '../../common/InputValidationProps';
export interface TextAreaProps extends TextareaHTMLAttributes<HTMLTextAreaElement>, Omit<ComponentWithClass, 'children'>, InputValidationProps {
    /**
     * Toggles whether the component is disabled or not (preventing user interaction).
     */
    isDisabled?: boolean;
    /**
     * Label to display within the component.
     */
    label: string;
    /**
     * Optional handler invoked when the `onBlur` event is emitted.
     */
    onBlur?: (event: React.FormEvent) => void;
    /**
     * Optional HTML `value` attribute to apply to the component.
     */
    value?: string;
}
export declare const TextArea: React.ForwardRefExoticComponent<TextAreaProps & React.RefAttributes<HTMLTextAreaElement>>;
//# sourceMappingURL=TextArea.d.ts.map