import React from 'react';
import { ComponentWithClass } from '../../common/ComponentWithClass';
export interface TimelineEventWithRenderContentProps extends ComponentWithClass {
    /**
     * The color of the bar.
     */
    barColor?: never;
    /**
     * Supply children to be rendered.
     */
    children?: never;
    /**
     * The end date of the event.
     */
    endDate: Date;
    /**
     * Supply a custom presentation layer.
     */
    render: (props: {
        startDate: Date;
        endDate: Date;
        widthPx: string;
        offsetPx: string;
        maxWidthPx: string;
        startsBeforeStart: boolean;
        endsAfterEnd: boolean;
    }) => React.ReactNode;
    /**
     * The start date of the event.
     */
    startDate: Date;
}
export interface TimelineEventWithChildrenProps extends ComponentWithClass {
    /**
     * The color of the bar.
     */
    barColor?: string;
    /**
     * Supply children to be rendered.
     */
    children: React.ReactNode;
    /**
     * The end date of the event.
     */
    endDate: Date;
    /**
     * Supply a custom presentation layer.
     */
    render?: never;
    /**
     * The start date of the event.
     */
    startDate: Date;
}
export type TimelineEventProps = TimelineEventWithRenderContentProps | TimelineEventWithChildrenProps;
export declare const TimelineEvent: React.FC<TimelineEventProps>;
//# sourceMappingURL=TimelineEvent.d.ts.map