import React from 'react';
import { ValueOf } from '../../helpers';
import { TIMELINE_BLOCK_SIZE } from './constants';
export type BlockSizeType = ValueOf<typeof TIMELINE_BLOCK_SIZE>;
export interface TimelineHoursWithRenderContentProps {
    /**
     * Number of hours per block in a day.
     */
    blockSize?: BlockSizeType;
    /**
     * Supply a custom presentation layer.
     */
    render: (props: {
        width: number;
        time: string;
    }) => React.ReactElement;
}
export interface TimelineHoursWithChildrenProps {
    blockSize?: BlockSizeType;
    render?: never;
}
export type TimelineHoursProps = TimelineHoursWithRenderContentProps | TimelineHoursWithChildrenProps;
export declare const TimelineHours: React.FC<TimelineHoursProps>;
//# sourceMappingURL=TimelineHours.d.ts.map