import React from 'react';
import { CSSProp } from 'styled-components';
import { ComponentWithClass } from '../../common/ComponentWithClass';
import { SubcomponentProps } from '../../common/SubcomponentProps';
import { TimelineEventsProps } from '.';
export interface TimelineRowProps extends ComponentWithClass {
    /**
     * Supply children to be rendered.
     */
    children: React.ReactElement<TimelineEventsProps> | React.ReactElement<TimelineEventsProps>[];
    /**
     * A styled-components css`` value to modify the CSS.
     */
    css?: CSSProp;
    /**
     * A descriptive identifier for the row.
     */
    name?: string;
    /**
     * @private
     */
    ariaLabel?: string;
    /**
     * Ability to pass props to the content div of the row.
     */
    contentProps?: SubcomponentProps;
    /**
     * Ability to pass props to the header div of the row.
     */
    headerProps?: SubcomponentProps;
    /**
     * Supply a custom presentation layer for the row header.
     */
    render?: (props: {
        name?: string;
    }) => React.ReactElement;
    /**
     * @private
     */
    isHeader?: boolean;
}
export declare const TimelineRow: React.ForwardRefExoticComponent<TimelineRowProps & React.RefAttributes<HTMLDivElement>>;
//# sourceMappingURL=TimelineRow.d.ts.map