import React from 'react';
import { ComponentWithClass } from '../../common/ComponentWithClass';
import { TimelineRowProps } from '.';
type TimelineRowsChildrenType = React.ReactElement<TimelineRowProps> | React.ReactElement<TimelineRowProps>[];
export interface TimelineRowsProps extends ComponentWithClass {
    /**
     * Supply children to be rendered.
     */
    children: TimelineRowsChildrenType;
    /**
     * Supply a custom presentation layer.
     */
    render?: (props: {
        index: number;
        isOddNumber: boolean;
        offsetPx: string;
        widthPx: string;
    }) => React.ReactElement;
    /**
     * Toggle denoting whether to virtualize the rows.
     *
     * The native sidebar cannot currently be used with virtualized rows.
     */
    isVirtualized?: boolean;
}
export declare const TimelineRows: React.FC<TimelineRowsProps>;
export {};
//# sourceMappingURL=TimelineRows.d.ts.map