import React from 'react';
import { PositionType } from '../../common/Position';
import { TOOLTIP_POSITION } from '.';
import { ValueOf } from '../../helpers';
export type TooltipPositionType = ValueOf<typeof TOOLTIP_POSITION>;
export interface TooltipProps extends PositionType {
    /**
     * Text to display within the tooltip.
     */
    children?: React.ReactNode;
    /**
     * Optional HTML `id` attribute.
     */
    id?: string;
    /**
     * Where to position the tooltip relative to the target element.
     */
    position?: TooltipPositionType;
    /**
     * Optional text title to display above the tooltip text.
     */
    title?: string;
    /**
     * Optional fixed width of the component.
     */
    width?: number;
}
export declare const Tooltip: React.FC<TooltipProps>;
//# sourceMappingURL=Tooltip.d.ts.map