import React from 'react';
import { ComponentWithClass } from '../../../common/ComponentWithClass';
import { LinkTypes } from '../../../common/Link';
import { MastheadUserItemProps } from './MastheadUserItem';
import { Nav } from '../../../common/Nav';
export interface MastheadUserWithItemsProps extends Nav<MastheadUserItemProps> {
    /**
     * Initials of the end user (e.g. Joe Bloggs => JB).
     */
    initials: string;
    /**
     * Link component to apply to the user avatar.
     */
    link?: never;
    /**
     * @private
     */
    initialIsOpen?: boolean;
}
export interface MastheadUserWithLinkProps extends ComponentWithClass {
    children?: never;
    /**
     * Initials of the end user (e.g. Joe Bloggs => JB).
     */
    initials: string;
    /**
     * Link component to apply to the user avatar.
     */
    link: React.ReactElement<LinkTypes>;
}
export type MastheadUserProps = MastheadUserWithLinkProps | MastheadUserWithItemsProps;
export declare const MastheadUser: React.FC<MastheadUserProps>;
//# sourceMappingURL=MastheadUser.d.ts.map