import React from 'react';
import { SidebarUserProps } from './SidebarUser';
import { ComponentWithClass } from '../../../common/ComponentWithClass';
import { NotificationsProps } from '../NotificationPanel';
export interface SidebarProps extends ComponentWithClass {
    /**
     * Optional icon to display at the top of the component (JSX).
     */
    icon?: React.ReactNode;
    /**
     * Optional text title to display at the top of the component.
     */
    title?: string;
    /**
     * Optional JSX to render a user menu.
     */
    user?: React.ReactElement<SidebarUserProps>;
    /**
     * Toggle whether there are unread notifications.
     */
    hasUnreadNotification?: boolean;
    /**
     * Optional JSX to render a collection of notifications.
     */
    notifications?: React.ReactElement<NotificationsProps>;
    /**
     * Whether the notifications list is initially open.
     * @private
     */
    initialIsNotificationsOpen?: boolean;
    /**
     * Initial `isOpen` state on first render.
     */
    initialIsOpen?: boolean;
}
export declare const Sidebar: React.FC<SidebarProps>;
//# sourceMappingURL=Sidebar.d.ts.map