import React from 'react';
import { useFloatingElement } from './useFloatingElement';
export declare const CLICK_BUTTON: {
    readonly LEFT: "left";
    readonly RIGHT: "right";
};
export type ClickType = typeof CLICK_BUTTON[keyof typeof CLICK_BUTTON];
interface UseClickMenuParams {
    attachedToRef: React.RefObject<HTMLElement>;
    clickType: ClickType;
    initialIsOpen: boolean;
    onHide?: (e: MouseEvent) => void;
    onShow?: (e: MouseEvent) => void;
}
type UseClickMenuReturnType = {
    isOpen: boolean;
} & ReturnType<typeof useFloatingElement>;
export declare const useClickMenu: ({ attachedToRef, clickType, initialIsOpen, onHide, onShow, }: UseClickMenuParams) => Omit<UseClickMenuReturnType, 'forceUpdate'>;
export {};
//# sourceMappingURL=useClickMenu.d.ts.map