import React from 'react';
/**
 * Handle document click
 * @param nodes - if the click is inside a node then document click event will
 * not be raised
 *
 * @param onDocumentClick - if the click is outside of nodes then the callback
 * will be raised. Use useCallback for this to avoid the event listener being
 * reattached unnecessarily
 *
 * @param isEnabled - whether the on click handler is enabled. Can be set
 * to false if the hook needs to be enabled or disabled dynamically
 */
export declare function useDocumentClick(nodes: React.RefObject<Element | null> | React.RefObject<Element | null>[], onDocumentClick: (event: Event) => void, isEnabled?: boolean): void;
//# sourceMappingURL=useDocumentClick.d.ts.map