/// <reference types="react" />
/**
 * Small wrapper around useState for keeping a ref value in the state.
 *
 * @example
 * const [element, setElement] = useStatefulRef()
 * <input ref={setElement} />
 */
export declare function useStatefulRef<ValueType = Element>(): [ValueType | null, import("react").Dispatch<import("react").SetStateAction<ValueType | null>>];
//# sourceMappingURL=useStatefulRef.d.ts.map